<template>
  <!-- Cards -->
  <div class="b-box-card">
      <el-card :body-style="{ padding: '0px' }" class="bg-gray">
          <el-row :gutter="24" style="display: flex;">
            <!-- titulo principal -->
            <el-col :span="9" style="background: white;">
              <div style="margin: 4rem 0 0 2.5rem" >
                <div class="title-styles" style="margin-bottom:2rem" v-text="principalTitle"></div>
                <div class="infoToShow__box">
                  <div style="margin: 18px auto; font-size: 18px" v-for="(text, i) in infoToShow" :key="i">
                    <span class="infoToShow__title"><strong>{{text.title}}</strong></span>
                    <span style="color: #8F8F8F">{{ text.content}}</span>
                  </div>
                  <div class="emission-status" v-if="canned == true">
                    <span class="status-repetition" v-if="emissionStatus === 'Repetición'"><b>{{ emissionStatus }}</b></span>
                    <span class="status-premiere" v-else><b>{{ emissionStatus }}</b></span>
                  </div>                  
                </div>

                <div v-if="showAmounts == true">
                  <div v-for="(value, index) in principalData" :key="index" 
                        v-bind:class="value.class" class="subtitle-styles box-text1" style="margin-bottom:2rem">{{value.subTitle}}:
                    <span v-text="value.content"></span>
                  </div>
                </div>
                
                <!-- tabla de vigencia -->
                <div v-if="showvalidity == true">
                  <el-table :data="dataTable" size="medium" style="width: 90%; margin-bottom: 25px;" :header-cell-class-name="tableRowClassName">
                    <el-table-column label="VIGENCIA">
                      <el-table-column type="expand" v-if="showWindow == true">
                        <template slot-scope="props">
                          <p class="bg-orange text-white" style="margin-bottom: 4px; padding: 4px">Ventanas</p>
                          <p>{{ props.row.startWindow }} - {{ props.row.endWindow }}</p>
                        </template>
                      </el-table-column>
                      <el-table-column type="index"></el-table-column>
                      <el-table-column label="Inicio" >
                        <template slot-scope="props">
                          <p>{{ dataFilter(props.row.startValidity) }} </p>
                        </template>
                      </el-table-column>
                      <el-table-column label="Fin">
                        <template slot-scope="props">
                          <p>{{ dataFilter(props.row.endValidity) }} </p>
                        </template>
                      </el-table-column>
                    </el-table-column>
                  </el-table>
                </div>
                
              </div>
            </el-col>
            
            <!-- informacion general -->
            <el-col :span="14">
              <el-row type="flex" class="row-bg" justify="end">
                <!-- Componente de botones editar/ hacer cortes/ dar de baja-->
                <app-card-buttons :textModal="textModal" :uniqueId="uniqueId" :item="item" :editRoute="editRoute" @editEvent="emitEdit" @status="emitChangeStatus" :cutRoute="isOldMaterial(item.codMaterial)"></app-card-buttons>
              </el-row>
              <div style= "padding: 0.5rem 0 3rem 2.5rem">
                <div class="line-heigth">
                  <!-- Season -->
                  <div v-if="positionSeason == 'top'">
                    <el-row v-if="showSeason.length > 0" :class="{'showScroll': showSeason.length > 2}">
                      <el-col :span="12" v-for="(item, i) in showSeason" :key="i" style="height: 60px;">
                        <div><span class="subtitle-styles">{{'Temporada ' + item.season + ':'}}</span></div>
                        <div>{{item.chapters + ' Capítulos'}}</div>
                        <br>                      
                      </el-col>
                    </el-row>
                    <hr class= "line-card" v-if="showSeason.length > 0">
                  </div>
                  <!-- Segments -->
                  <el-row v-if="showTitleSegment">
                    <el-col :span="12" v-for="(item, i) in infoTitleSegment" :key="i" style="height: 60px;">
                      <div><span class="subtitle-styles">{{ item.left.subTitle + ':'}}</span></div>
                      <div>
                        <span class="font-general" v-html="item.left.content"></span>
                      </div>                     
                    </el-col>
                  </el-row>
                  <hr class= "line-card" v-if="infoTitleSegment !== undefined">
                  <!-- Details -->
                  <div v-for="(value, index) in rowsInfo" :key="index">
                    <div v-if="value.hideWithChapters == false || value.hideAfiliado == false || value.showDefault == true">
                     <!-- {{ value }} -->
                      <el-row style="margin-bottom: 1rem">
                        <el-col :span="12">
                          <span class="subtitle-styles">
                            {{value.left.subtitle}}:
                          </span>
                          <div v-if=" typeof(value.left.content) === 'string'" style="word-break: break-word">
                            <span class="font-general" v-html="value.left.content"></span>
                          </div>
                          <div v-else-if="Array.isArray(value.left.content)">
                            <span v-if="value.left.content.length === 13">
                              <span style="margin-left:2rem" class="font-general"> Todas las señales</span>
                            </span>
                            <span v-else > 
                              <span> {{value.left.content}} </span>
                            </span>                            
                          </div>
                          <div v-else>
                            <!-- <el-row  >
                              <el-col :span="11"> 
                                 <strong>Inicio:</strong>  <span v-text="value.left.content.inicio" style="margin-left: 0.5rem"></span>
                              </el-col>
                              <el-col :span="7">
                                 <strong>Fin:</strong>  <span v-text="value.left.content.fin" style="margin-left: 0.5rem"></span>
                              </el-col>
                            </el-row> -->
                          </div>
                        </el-col>
                        <el-col :span="12" v-if="value.right">
                          <span class="subtitle-styles">
                            {{value.right.subtitle}}:
                          </span>
                          <div>
                            <span class="font-general" v-html="value.right.content"></span>
                          </div>
                        </el-col>
                      </el-row>
                      <hr class= "line-card" v-if="Object.keys(rowsInfo).length -1 > index">
                    </div>
                  </div>

                  <div v-if="positionSeason == 'bottom'">
                    <hr class= "line-card" v-if="showSeason.length > 0">
                    <el-row v-if="showSeason.length > 0" :class="{'showScroll': showSeason.length > 2}">
                      <el-col :span="12" v-for="(item, i) in showSeason" :key="i" style="height: 60px;">
                        <div><span class="subtitle-styles">{{'Temporada ' + item.season + ':'}}</span></div>
                        <div>{{item.chapters + ' Capítulos'}}</div>
                        <br>                      
                      </el-col>
                    </el-row>
                  </div>

                  <!-- Detalle de pasadas -->
                  <div style="margin: 2rem 0 1rem" v-if="passSection !== undefined">
                    <div class="bg-dark-gray-2 text-white subtitle-styles" style="margin-bottom: 1rem; padding: 0 6px">DETALLE DE PASADAS</div>
                    <div v-for="(value, index) in passSection" :key="index" v-if="value.hideAfiliado == false">
                      <span class="fonts-bold-general" style="line-height: 2">{{value.passSubtitle}}:</span>
                      <span v-text="value.content" style="margin-left: 1rem"></span>
                      <span v-text="value.passPrice" v-if="value.passPrice !== ''"></span>
                    </div>
                    <hr class= "line-card">
                  </div>

                  <!-- Detalle de Emision -->
                  <div style="margin: 2rem 0 1rem" v-if="emission !== undefined">                  
                    <div v-if="showSeason.length > 0" >
                      <div class="subtitle-styles">Emisión del Último Capítulo:</div>
                      <div>
                         <!-- las emisiones se muestran cuando se programa en parrilla --> 
                         <span style="margin-top: 1rem" v-for="(emi, index) in showSeason[0].infoByChapter[showSeason[0].infoByChapter.length -1].emissions" :key="index">
                        <span> {{ new Date(emi) < new Date() ? new Date(emi).toLocaleDateString('en-GB') : '' }}  <span style="margin: 10px" v-if="index < (showSeason[0].infoByChapter[showSeason[0].infoByChapter.length -1].emissions.length -1) "> |  </span> </span>
                       </span>
                      </div>
                    </div>
                    <div v-else >
                      <div class="subtitle-styles">Emisiones: </div>
                        <span style="margin-top: 1rem" v-for="(emi, index) in emission" :key="index">
                          <span v-if="emi !== 'No emitido'"> {{ new Date(emi) < new Date() ? new Date(emi).toLocaleDateString('en-GB') : '' }}  <span style="margin: 10px" v-if="index < (emission.length -1) "> |  </span> </span>
                          <span v-else> {{ emi }} </span>
                       </span>
                    </div>
                  </div>
                  <!-- Actors -->
                  <div v-if="(showActors !== undefined) && (showSeason.length == 0)">
                    <div class="subtitle-styles">Actors:</div>
                    <div v-for="(item, i) in Object(showActors.artisticInfo)" :key="i">
                      <div>
                        <i class="el-icon-star-on color-star"></i>
                        {{item.mainActors[0]}}
                      </div>
                      <div>
                        <i class="el-icon-star-on color-star"></i>{{item.mainActors[1]}}
                      </div>
                    </div>                         
                  </div>
                  <!-- -->
                </div>
              </div>
            </el-col>
          </el-row>
          
      </el-card>
      
  </div>
</template>

<script>
  import crudCards from '@/components/cardButtons.vue'

  export default {
    name: 'app-cards',
    components: {
      'app-card-buttons': crudCards
    },
    props: {
      principalTitle: String,
      infoToShow: Object,
      principalData: Object,
      emissionStatus: {
        type:String,
        default: undefined,
        required: false
      },
      infoTitleSegment: [Object, Array ],
      showTitleSegment: Boolean,
      dataTable: Array,
      showvalidity: Boolean,
      rowsInfo: Object,
      canned: {
        type: Boolean,
        required: false
      },
      /*Props of the child component*/
      textModal: String,
      uniqueId: String,
      item: Object,
      cutRoute: Boolean,
      // routeCut: Promise,
      // routeCut: Object,
      editRoute: String,
      showSeason: Array,
      showActors: Object,
      positionSeason: {
        type: String,
        required: false
      },
      passSection: {
        type: Object,
        required: false
      },
      emission: {
        type: Array,
        required: false
      },
      showAmounts:{
        type: Boolean,
        required: false
      },
      showWindow: {
        type: Boolean,
        required: false
      }
    },
    data () {
      return {
        // value: ''
      }
    },
    methods: {
      dataFilter(text) {
        if(text === 'Invalid Date') {
          return ''
        } else {
          return text
        }
      },
      tableRowClassName ({row, rowIndex}) {
        if (rowIndex === 0) {
          return 'first-row-header';
        }
        if (rowIndex === 1) {
          return 'second-row-header';
        }
      },
      
      /*Emit child component event for send to parent*/
      emitEdit($event, item) {
        this.$emit('executeEdit', $event, item)
      },
      emitChangeStatus(item) {
        this.$emit('executeChangeStatus', item)
      },
      // async resolvePromise(val) {
      //     // let a = await this.routeCut
      //     // 
      //     // if(a) {
      //       // console.log(a, 'shjsj')
      //       return val ? `/${this.cutRoute}`: ''
      //     // } else {
      //     //   return ''
      //     // }
          
      // },
      isOldMaterial(val) {
        let route = this.$route.name
        if(route === "material2" || route === "material" ) {
          return true
        } else {
          return false
        }
      }
    },
    computed: {
      showSeasonExist() {
        if(this.showSeason) {
          return this.showSeason.length > 0 ? true : false
        } else {
          return false
        }
      }
    },
    // async created() {
    //   this.value = this.routeCut
    //   // this.value = await this.resolvePromise(this.routeCut)
    // }
  }
</script>

<style>
  .emission-status {
    margin-bottom: -25px;
  }
  .status-repetition {
    color: #219653;
    font-size: 16px;
    text-transform: uppercase;
  }
  .status-premiere {
    color: #FC0000; 
    font-size: 16px;
    text-transform: uppercase;
  }
  .color-star {
    color: #FF7333;
  }
  .bg-pasadas{
    background: #828282;
  }
  .infoToShow__title{
    width: 200px; 
    display: inline-block; 
    font-weight: 500;
  }

  .infoToShow__box{
    margin: 50px auto 40px; 
    /* padding: 0 5px; */
  }

  .showScroll{
    height: 60px; 
    overflow-y: scroll;
  }
</style>
